//+------------------------------------------------------------------+
//|                         MTF_MACDZeroLag Line.mq4                 |
//|                                                                  |
//|                                      marynarz15@wp.pl         ik                       |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006,    marynarz15@wp.pl"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property  indicator_buffers 2
#property indicator_color1 SlateGray
#property indicator_color2 OrangeRed
#property indicator_level1 0
#property indicator_width1 2
#property indicator_style2 2
//---- input parameters
extern int TimeFrame=0;
extern int       FastEMA=12;
extern int       SlowEMA=26;
extern int       SignalSMA=9;
//---- indicator buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
**************************************************************************/
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
//   SetIndexStyle(0,DRAW_SECTION,STYLE_SOLID,1);
//   SetIndexStyle(1,DRAW_SECTION,STYLE_SOLID,1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(0,SlowEMA);
   SetIndexDrawBegin(1,SlowEMA);
   SetIndexLabel(0,"MTF_MACD_L["+FastEMA+ ", "+SlowEMA+", "+SignalSMA+"]tf("+ TimeFrame+")");
   SetIndexLabel(1,"MTF_MACD_L Signal["+FastEMA+ ", "+SlowEMA+","+SignalSMA+"tf("+TimeFrame+")");


//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="";
   } 
   string short_name;
   short_name="MTF_MACD_L";
   IndicatorShortName(short_name+ "("+ TimeFrame+")["+FastEMA+","+SlowEMA+","+SignalSMA+"]");  
  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF Moving Average                                   |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  

   ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"MACD",FastEMA,SlowEMA,SignalSMA,0,y);
   ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,"MACD",FastEMA,SlowEMA,SignalSMA,1,y);

   }  
//Refreshing buffers ++++++++++++++++++++++++++++++++++++ by Raff
   if (TimeFrame>Period()) {
     int PerINT=TimeFrame/Period()+1;
     datetime TimeArr[]; ArrayResize(TimeArr,PerINT);
     ArrayCopySeries(TimeArr,MODE_TIME,Symbol(),Period()); 
     for(i=0;i<PerINT+1;i++) {if (TimeArr[i]>=TimeArray[0]) {
//----
 /****************************************************************   
    Refresh buffers:         buffer[i] = buffer[0];
 ****************************************************************/  

   ExtMapBuffer1[i]=ExtMapBuffer1[0];
   ExtMapBuffer2[i]=ExtMapBuffer2[0];

//----
   } } }
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++  Raff 
    
   return(0);
  }
//+------------------------------------------------------------------+